	movem.l $ffff8240.w,d0-d7
	movem.l d0-d7,-(a7)		; save pallette

	ifd force_512k
	move.l #$80000,$42e.w		; set "ramtop" to 512k
	endc

 	move.l #'DBUG',highest_address-4	; test enough memory
	cmp.l #'DBUG',highest_address-4
	beq enough_ram
	pea .not_enough_ram(pc)		; display error
	move.w #9,-(a7)
	trap #1
	lea 6(a7),a7
	move.w #7,-(a7)
	trap #1
	addq.l #2,a7

	movem.l (a7)+,d0-d7		; clean exit out
	movem.l d0-d7,$ffff8240.w

	rts

.not_enough_ram
	dc.b "Requires 2MB+",0
	even


scanline	equ 193		; vertical line to put scrolly on


enough_ram	
	ifnd mste_16mhz

	move.l	#"_MCH",d1	;cookie we want	
	move.l	$5a0.w,d0	;get address of cookie jar in d0
	beq.s	.nojar		;If zero, there's no jar.
	move.l	d0,a0		;move the address of the jar to a0
.search	tst.l	(a0)		;is this jar entry the last one ?
	beq.s	.nofind		;yes, the cookie was not found
	cmp.l	(a0),d1		;does this cookie match what we're looking for?
	beq.s	.foundit	;yes, it does.
	addq.l	#8,a0		;advance to the next jar entry
	bra.s	.search		;and start over
.nofind	moveq	#-1,d0		;a negative (-1) means cookie not found
	bra.s	.cookieexit
.nojar	moveq	#-2,d0		;a negative (-2) means there's no jar
	bra.s	.cookieexit
.foundit	
	nop
	cmp.l	#$00010010,4(a0)	; is it a mste?
	bne.s	.cookieexit
	clr.b	$ffff8e21.w		; Set 8mhz
.cookieexit
	endc 

	move.w 	#$2700,sr

	ifd simple_mfp_code		; save MFP status before doing anything
	 move.b $fffffa07.w,HD_MFP
	 move.b $fffffa09.w,HD_MFP+1
	 move.b $fffffa15.w,HD_MFP+2
	 move.b $fffffa1b.w,HD_MFP+3
	 move.b $fffffa25.w,HD_MFP+4	; <-- "simple codepath"
	 move.b $fffffa23.w,HD_MFP+5
	 move.b $fffffa21.w,HD_MFP+6
	 move.b $fffffa1f.w,HD_MFP+7
	 move.b $fffffa1d.w,HD_MFP+8
	endc

	ifnd simple_mfp_code
	 lea	GEMmfp_save(pc),a1
         bsr     save_mfp
         lea     GEMta_control(PC),A0
         lea     GEMta_data(PC),A3
         bsr     save_timers
         move    #$2700,SR		; <-- "Advanced codepath"
         lea     GEMta_data(PC),A3
         lea     GEMta_control(PC),A4
         bsr     restore_timers
	 lea	GEMmfp_save(pc),a1
         bsr     restore_mfp
         bsr     flush_acia
	endc

; if not in auto-eoi mode, the interrupt-in service registers have to be
; cleared !
	ifd autoeoi
        clr.b   $FFFFFA0F.w
        clr.b   $FFFFFA11.w
	endc

	move.w	#$2300,sr

	clr.b $484.w			; Disable Keyclick

	clr.w -(a7)			; screen to $78000
	pea start_screen
	pea start_screen
	move.w #5,-(a7)
	trap #14
	add.l #12,a7

;	jsr tiny_menu			; call intro

	clr.w $ffff8240.w

	bsr HD_Bug_Init		; Init High RAM

